﻿using System;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;
using System.Diagnostics;

namespace CustomSummaryCalculator
{
    public class CustomCalculator : SummaryCalculator
    {
        Double remaining;
        public Double amount { get; set; }

        public override void Aggregate(object dataValue, SummaryResult summaryResult, Record record)
        {
            remaining -= Convert.ToDouble(dataValue);
        }

        //THIS IS THE FUNCTION I ADD FOR CHECKING
        private bool IsTemplateCollSummary(SummaryResult summaryResult)
        {
            Record record = summaryResult.ParentCollection.Records.ParentRecord;
            return null != record && RecordType.GroupByFieldLayout == record.RecordType;
        }

        public override void BeginCalculation(SummaryResult summaryResult)
        {
            //HERE IS THE CHECK
            if (this.IsTemplateCollSummary(summaryResult))
                return;

            Debug.WriteLine("BeginCalculation is called !");
            remaining = amount;
        }


        public override bool CanProcessDataType(Type dataType)
        {
            return Utilities.IsNumericType(dataType);
        }

        public override string Description
        {
            get
            {
                return "Custom Calculator";
            }
        }

        public override object EndCalculation(SummaryResult summaryResult)
        {
            //HERE IS THE CHECK
            if (this.IsTemplateCollSummary(summaryResult))
                return null;

            Debug.WriteLine("EndCalculation is called !");
            return remaining;
        }

        public override string Name
        {
            get
            {
                return "CustomCalculator";
            }
        }

        public override string ApplyDefaultFormat(object summaryResultValue, SummaryResult context)
        {
            return string.Format("{0} {1} {2}", "Summary Result  ", "Remaining Quantity  ", summaryResultValue);
        }
    }
}
